LeetCode-移除元素(27)&& 合并两个有序数组(88)

1.移除元素(27)

题目描述:

给你一个数组 nums 和一个值 val,你需要 原地 移除所有数值等于 val 的元素,并返回移除后数组的新长度。

不要使用额外的数组空间,你必须仅使用 O(1) 额外空间并 原地 修改输入数组。

元素的顺序可以改变。你不需要考虑数组中超出新长度后面的元素。

提示:

0 <= nums.length <= 100

0 <= numsi <= 50

0 <= val <= 100

思路: 因为这里要删除指定值的数组元素,按照题目的意思就是把要删除的元素放到数组最后即可。然后值得范围是0~100,这样我们就可以想到将和指定值相等的元素赋为101,然后将数组排序,这样要删除的元素都排到数组之后了。感觉这算是一种钻空子的做法。
代码:

java 复制代码
class Solution {
    public int removeElement(int[] nums, int val) {
        int count=0;
       for(int i=0;i<nums.length;i++) {
           if(nums[i]==val) {
               nums[i]=101;
               count++;
           }
       }
        Arrays.sort(nums);

        return nums.length-count;
    }
}

官方题解:

java 复制代码
class Solution {
    public int removeElement(int[] nums, int val) {
        int n = nums.length;
        int left = 0;
        for (int right = 0; right < n; right++) {
            if (nums[right] != val) {
                nums[left] = nums[right];
                left++;
            }
        }
        return left;
    }
}

这是官方给的一种双指针方法。left指向的是最终保存的数组,right是指向待判断的元素,如果元素不和val值相等则添加到最终数组,否则跳过。

2.合并两个有序数组(88)

题目描述:

给你两个按 非递减顺序 排列的整数数组 nums1 和 nums2,另有两个整数 m 和 n ,分别表示 nums1 和 nums2 中的元素数目。

请你 合并 nums2 到 nums1 中,使合并后的数组同样按 非递减顺序 排列。

注意:最终,合并后数组不应由函数返回,而是存储在数组 nums1 中。为了应对这种情况,nums1 的初始长度为 m + n,其中前 m 个元素表示应合并的元素,后 n 个元素为 0 ,应忽略。nums2 的长度为 n 。

思路: 因为最终两个数组元素要保存到第一个数组中,所以从两个数组的末端元素开始比较,更大的元素保存到第一个数组的最后一个空间,然后继续比较,更大元素保存到第一个数组的倒数第二个空间等等依次进行操作。然后一个数组处理完了跳出循环,最后通过一个循环处理另一个数组的元素。

代码:

java 复制代码
class Solution {
    public void merge(int[] nums1, int m, int[] nums2, int n) {
        int k=m+n-1;
        m=m-1;
        n=n-1;
        while(m>=0&&n>=0) {
            if(nums1[m]<=nums2[n]) {
                nums1[k]=nums2[n];
                k--;
                n--;
            } else {
                nums1[k]=nums1[m];
                k--;
                m--;
            }
        }

        while(n>=0) {
            nums1[k]=nums2[n];
            k--;
            n--;
        }

        while(m>=0) {
            nums1[k]=nums1[m];
            k--;
            m--;
        }
    }
}
相关推荐
吞下星星的少年·-·2 小时前
Div.3 CF 1131A题(排序,模拟)
算法·模拟·排序
圣保罗的大教堂2 小时前
leetcode 453. 最小操作次数使数组元素相等 中等
leetcode
aichitang20242 小时前
代数拓扑学与现代前沿视角
考研·算法·数学建模·ai·拓扑学·高考
二本咕咕-机械转码3 小时前
FreeRTOS深入解析(一)_链表与并发保护——哨兵循环链表、排序键游标、临界区与关调度
单片机·算法·链表
-银雾鸢尾-3 小时前
两数之和-C++实现
c++·算法
j7~3 小时前
【动态规划算法专题】动态规划五部曲实战:泰波那契数、三步问题、最小花费爬楼梯
c++·算法·动态规划·数据结构与算法
倍利福猎头公司官方账号3 小时前
大企业HR如何向猎头公司清晰传达AI岗位的技术需求?
人工智能·算法·机器人·求职招聘·业界资讯
揽星河..4 小时前
【C++】类和对象
c++·算法
D e re k ZH4 小时前
C++ 并发、未定义行为与工程化难点(No 3)
数据结构·c++·算法·面试